Subject: Re: RMNET QMAP data aggregation with size greater than 16384

From: [email-masked]
Date: Fri, 06 Aug 2021 12:42:49 -0600

> I tried with a SIMCOM 7600E, with data aggregation enabled with QMAPv1:
> 
> $ sudo qmicli -d /dev/cdc-wdm0 -p --wda-get-data-format
> [/dev/cdc-wdm0] Successfully got data format
>                    QoS flow header: no
>                Link layer protocol: 'raw-ip'
>   Uplink data aggregation protocol: 'qmap'
> Downlink data aggregation protocol: 'qmap'
>                      NDP signature: '0'
> Downlink data aggregation max datagrams: '10'
> Downlink data aggregation max size: '4096'
> 
> As you suggested, the MTU of the new muxed interface is set to 1500
> and the MTU of the master interface to only 4 more bytes (1504):
> 
> # ip link
> 8: wwp0s20f0u8u4i5: <POINTOPOINT,UP,LOWER_UP> mtu 1504 qdisc fq_codel
> state UNKNOWN mode DEFAULT group default qlen 1000
>     link/none
> 9: qmapmux0.0@wwp0s20f0u8u4i5: <UP,LOWER_UP> mtu 1500 qdisc fq_codel
> state UNKNOWN mode DEFAULT group default qlen 1000
>     link/[519]
> 
> Under this scenario, the downlink is completely broken (speedtest
> 0.39Mbps), while the uplink seems to work (speedtest 13Mbps).
> 
> If I use the logic I had before, associating the downlink data
> aggregation max size reported by the module to the MTU of the master
> interface, same as I had to do when using qmi_wwan add_mux/del_mux,
> then it works properly:
> 
> # ip link
> 14: wwp0s20f0u8u4i5: <POINTOPOINT,UP,LOWER_UP> mtu 4096 qdisc fq_codel
> state UNKNOWN mode DEFAULT group default qlen 1000
>     link/none
> 15: qmapmux0.0@wwp0s20f0u8u4i5: <UP,LOWER_UP> mtu 1500 qdisc fq_codel
> state UNKNOWN mode DEFAULT group default qlen 1000
>     link/[519]
> 
> Downlink is now 26Mbps and uplink still 13Mbps.
> 
> Is there something I'm doing wrong? Or do we really need to do the
> same thing as in qmi_wwan add_mux/del_mux; i.e. configuring the master
> interface MTU to be the same as the downlink max aggregation data size
> so that we change the rx_urb_size?

Unfortunately, this seems to be a limitation of qmi_wwan (usbnet)
where its tying the RX to the TX size through usbnet_change_mtu.

Ideally, we should break this dependency and have a sysfs or some other
configuration scheme to set the rx_urb_size.

Looks like this discussion has happened a while back and the option to 
use
a configurable scheme for rx_urb_size was rejected by Bjorn and Greg KH.
The summary of the thread was to set a large rx_urb_size during probe 
itself for qmi_wwan.

https://patchwork.kernel.org/project/linux-usb/patch/[email-masked]/

We could try setting a large value as suggested there and it should 
hopefully
solve the issue you are seeing.

--
The Qualcomm Innovation Center, Inc. is a member of the Code Aurora 
Forum,
a Linux Foundation Collaborative Project